###################################################
### chunk number 1: 
###################################################
library(simctest)


###################################################
### chunk number 2:  eval=FALSE
###################################################
## vignette("simctest-intro")


###################################################
### chunk number 3: 
###################################################
res <- simctest(function() runif(1)<0.07);
res


###################################################
### chunk number 4: 
###################################################
confint(res)


###################################################
### chunk number 5: 
###################################################
res <- simctest(function() runif(1)<0.05);
res


###################################################
### chunk number 6: 
###################################################
res <- cont(res,10000)
res


###################################################
### chunk number 7: 
###################################################
data(fir,package="boot")
fir.mle <- c(sum(fir$count), nrow(fir))
fir.gen <- function(data, mle){
  d<-data
  y <- sample(x=mle[2],size=mle[1],replace=TRUE)
  d$count <- tabulate(y,mle[2])
  d
}
fir.fun <- function(data)
  (nrow(data)-1)*var(data$count)/mean(data$count)
resampl <- function(){
  obs<fir.fun(fir.gen(data=fir,mle=fir.mle))
}
obs<-fir.fun(fir)
simctest(resampl)


###################################################
### chunk number 8: 
###################################################
n <- 10
system.time(replicate(1000, {obs<-mean(rnorm(n)+0.01);simctest(function() mean(rnorm(n))>obs,maxsteps=1000)}));


###################################################
### chunk number 9: 
###################################################
system.time(replicate(1000, {obs<-mean(rnorm(n)+0.01);mean(replicate(1000, mean(rnorm(n))>obs))}));


###################################################
### chunk number 10: 
###################################################
alg <- getalgprecomp()
system.time(replicate(1000, {obs<-mean(rnorm(n)+0.01);run(alg,function() mean(rnorm(n))>obs,maxsteps=1000)}));


###################################################
### chunk number 11: 
###################################################
alg <- getalgonthefly()
system.time(replicate(1000, {obs<-mean(rnorm(n)+0.01);run(alg,function() mean(rnorm(n))>obs,maxsteps=1000)}));


